>From 7f443de10fa41cfa5c0311e7ad59edea11c2039c Mon Sep 17 00:00:00 2001
From: Richard Hansen <rhansen@bbn.com>
Date: Mon, 23 Jan 2012 20:55:11 -0500
Subject: [PATCH 2/2] remove osmpbf.jar from the source code repository

---
 .../repo/crosby/osmpbf/1.1.1-754a33af/ivys/ivy.xml |   19 -------------------
 .../osmpbf/1.1.1-754a33af/jars/dsiutils-1.0.11.jar |  Bin 392131 -> 0 bytes
 .../crosby/osmpbf/1.1.1-754a33af/jars/fastutil.jar |  Bin 212603 -> 0 bytes
 .../crosby/osmpbf/1.1.1-754a33af/jars/osmpbf.jar   |  Bin 192484 -> 0 bytes
 .../crosby/osmpbf/1.1.1-754a33af/jars/protobuf.jar |  Bin 300032 -> 0 bytes
 .../1.1.1-754a33af/jars/testng-5.9-jdk15.jar       |  Bin 853236 -> 0 bytes
 .../osmpbf/1.1.1-754a33af/jars/xpp3-1.1.4c.jar     |  Bin 120069 -> 0 bytes
 7 files changed, 0 insertions(+), 19 deletions(-)
 delete mode 100644 build-support/repo/crosby/osmpbf/1.1.1-754a33af/ivys/ivy.xml
 delete mode 100644 build-support/repo/crosby/osmpbf/1.1.1-754a33af/jars/dsiutils-1.0.11.jar
 delete mode 100644 build-support/repo/crosby/osmpbf/1.1.1-754a33af/jars/fastutil.jar
 delete mode 100644 build-support/repo/crosby/osmpbf/1.1.1-754a33af/jars/osmpbf.jar
 delete mode 100644 build-support/repo/crosby/osmpbf/1.1.1-754a33af/jars/protobuf.jar
 delete mode 100644 build-support/repo/crosby/osmpbf/1.1.1-754a33af/jars/testng-5.9-jdk15.jar
 delete mode 100644 build-support/repo/crosby/osmpbf/1.1.1-754a33af/jars/xpp3-1.1.4c.jar

diff --git a/build-support/repo/crosby/osmpbf/1.1.1-754a33af/ivys/ivy.xml b/build-support/repo/crosby/osmpbf/1.1.1-754a33af/ivys/ivy.xml
deleted file mode 100644
index 23b8866..0000000
--- a/build-support/repo/crosby/osmpbf/1.1.1-754a33af/ivys/ivy.xml
+++ /dev/null
@@ -1,19 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<ivy-module version="1.0" xmlns:m="http://ant.apache.org/ivy/maven">
-	<info organisation="crosby" module="osmpbf" revision="1.1.1-754a33af"/>
-	<configurations>
-		<conf name="default" visibility="public" description="runtime dependencies and master artifact can be used with this conf" extends="runtime,master"/>
-		<conf name="master" visibility="public" description="contains only the artifact published by this module itself, with no transitive dependencies"/>
-		<conf name="compile" visibility="public" description="this is the default scope, used if none is specified. Compile dependencies are available in all classpaths."/>
-		<conf name="provided" visibility="public" description="this is much like compile, but indicates you expect the JDK or a container to provide it. It is only available on the compilation classpath, and is not transitive."/>
-		<conf name="runtime" visibility="public" description="this scope indicates that the dependency is not required for compilation, but is for execution. It is in the runtime and test classpaths, but not the compile classpath." extends="compile"/>
-		<conf name="test" visibility="private" description="this scope indicates that the dependency is not required for normal use of the application, and is only available for the test compilation and execution phases." extends="runtime"/>
-		<conf name="system" visibility="public" description="this scope is similar to provided except that you have to provide the JAR which contains it explicitly. The artifact is always available and is not looked up in a repository."/>
-		<conf name="sources" visibility="public" description="this configuration contains the source artifact of this module, if any."/>
-		<conf name="javadoc" visibility="public" description="this configuration contains the javadoc artifact of this module, if any."/>
-		<conf name="optional" visibility="public" description="contains all optional dependencies"/>
-	</configurations>
-	<publications>
-		<artifact name="osmpbf" type="jar" ext="jar" conf="master"/>
-	</publications>
-</ivy-module>
diff --git a/build-support/repo/crosby/osmpbf/1.1.1-754a33af/jars/dsiutils-1.0.11.jar b/build-support/repo/crosby/osmpbf/1.1.1-754a33af/jars/dsiutils-1.0.11.jar
deleted file mode 100644
index fde9078..0000000
Binary files a/build-support/repo/crosby/osmpbf/1.1.1-754a33af/jars/dsiutils-1.0.11.jar and /dev/null differ
diff --git a/build-support/repo/crosby/osmpbf/1.1.1-754a33af/jars/fastutil.jar b/build-support/repo/crosby/osmpbf/1.1.1-754a33af/jars/fastutil.jar
deleted file mode 100644
index 32415b2..0000000
Binary files a/build-support/repo/crosby/osmpbf/1.1.1-754a33af/jars/fastutil.jar and /dev/null differ
diff --git a/build-support/repo/crosby/osmpbf/1.1.1-754a33af/jars/osmpbf.jar b/build-support/repo/crosby/osmpbf/1.1.1-754a33af/jars/osmpbf.jar
deleted file mode 100644
index 97221e9..0000000
Binary files a/build-support/repo/crosby/osmpbf/1.1.1-754a33af/jars/osmpbf.jar and /dev/null differ
diff --git a/build-support/repo/crosby/osmpbf/1.1.1-754a33af/jars/protobuf.jar b/build-support/repo/crosby/osmpbf/1.1.1-754a33af/jars/protobuf.jar
deleted file mode 100644
index b9e77c3..0000000
Binary files a/build-support/repo/crosby/osmpbf/1.1.1-754a33af/jars/protobuf.jar and /dev/null differ
diff --git a/build-support/repo/crosby/osmpbf/1.1.1-754a33af/jars/testng-5.9-jdk15.jar b/build-support/repo/crosby/osmpbf/1.1.1-754a33af/jars/testng-5.9-jdk15.jar
deleted file mode 100644
index 5090bcb..0000000
Binary files a/build-support/repo/crosby/osmpbf/1.1.1-754a33af/jars/testng-5.9-jdk15.jar and /dev/null differ
diff --git a/build-support/repo/crosby/osmpbf/1.1.1-754a33af/jars/xpp3-1.1.4c.jar b/build-support/repo/crosby/osmpbf/1.1.1-754a33af/jars/xpp3-1.1.4c.jar
deleted file mode 100644
index 451ac82..0000000
Binary files a/build-support/repo/crosby/osmpbf/1.1.1-754a33af/jars/xpp3-1.1.4c.jar and /dev/null differ
-- 
1.7.8.3